package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

public class ExampleMain4 {

    public static void main(String[] args) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("test2");
        try {
            persistEntity(emf);
            nativeQueries(emf);
            loadEntityC(emf);
            loadEntityD(emf);
        } finally {
            emf.close();
        }
    }

    private static void nativeQueries(EntityManagerFactory emf) {
        EntityManager em = emf.createEntityManager();
        ExampleMain.nativeQuery(em, "Select * from EntityC");
        ExampleMain.nativeQuery(em, "Select * from EntityD");
    }

    private static void persistEntity(EntityManagerFactory emf) {
        System.out.println("-- Persisting entities --");
        EntityManager em = emf.createEntityManager();
        EntityC entityC = new EntityC();
        EntityD entityD = new EntityD();
        entityD.setStr("testStringD");
        entityC.setRefEntityD(entityD);
        entityD.setRefEntityC(entityC);

        em.getTransaction().begin();
        em.persist(entityC);
        em.persist(entityD);
        em.getTransaction().commit();

        em.close();
    }

    private static void loadEntityC(EntityManagerFactory emf) {
        System.out.println("-- Loading EntityC --");
        EntityManager em = emf.createEntityManager();
        EntityC entityC = em.find(EntityC.class, 1);
        System.out.println(entityC);
        System.out.println(entityC.getEntityD());
        em.close();
    }

    private static void loadEntityD(EntityManagerFactory emf) {
        System.out.println("-- Loading EntityD --");
        EntityManager em = emf.createEntityManager();
        EntityD entityD = em.find(EntityD.class, 2);
        System.out.println(entityD);
        System.out.println(entityD.getRefEntityC());
        em.close();
    }
}